! Roba Rubata e che non viene usata

[ RestoreGame res fref;
    fref = glk($0062, $01, $02, 0); ! fileref_create_by_prompt
    fref = glk_fileref_create_by_prompt(fileusage_SavedGame+fileusage_BinaryMode, filemode_Read, 0);
    if (fref == 0) jump RFailed;
    gg_savestr = glk($0042, fref, $02, GG_SAVESTR_ROCK); ! stream_open_file
    glk($0063, fref); ! fileref_destroy
    if (gg_savestr == 0) jump RFailed;
    @restore gg_savestr res;
    glk($0044, gg_savestr, 0); ! stream_close
    gg_savestr = 0;
  .RFailed;
    "Caricamento Fallito.^";
];

[ SaveGame res fref;
    fref = glk($0062, $01, $01, 0); ! fileref_create_by_prompt
    if (fref == 0) jump SFailed;
    gg_savestr = glk($0042, fref, $01, GG_SAVESTR_ROCK); ! stream_open_file
    glk($0063, fref); ! fileref_destroy
    if (gg_savestr == 0) jump SFailed;
    @save gg_savestr res;
    if (res == -1) {
        ! The player actually just typed "restore". We're going to print
        !  L__M(##Restore,2); the Z-Code Inform library does this correctly
        ! now. But first, we have to recover all the Glk objects; the values
        ! in our global variables are all wrong.
        GGRecoverObjects();
        glk($0044, gg_savestr, 0); ! stream_close
        gg_savestr = 0;
        printedloc = 0;
        "Caricamento Effettuato.^";
    }
    glk($0044, gg_savestr, 0); ! stream_close
    gg_savestr = 0;
    if (res == 0) "Salvataggio Effettuato.^";
  .SFailed;
    "Salvataggio Fallito.^";
];

[ GGRecoverObjects rnew id;
    ! If GGRecoverObjects() has been called, all these stored IDs are
    ! invalid, so we start by clearing them all out.
    ! (In fact, after a restoreundo, some of them may still be good.
    ! For simplicity, though, we assume the general case.)
    gg_mainwin = 0;
    gg_statuswin = 0;
#IfDef STATUS_WIN_UFRAME;
    gg_statuswinuf = 0;
#Endif;    
    gg_savestr = 0;
    ! Also tell the game to clear its object references.
    IdentifyGlkObjectExt(0); 

    id = glk($0040, 0, gg_arguments); ! stream_iterate
    while (id) {
        switch (gg_arguments-->0) {
            GG_SAVESTR_ROCK: gg_savestr = id;
            default: IdentifyGlkObjectExt(1, 1, id, gg_arguments-->0);
        }
        id = glk($0040, id, gg_arguments); ! stream_iterate
    }
    id = glk($0020, 0, gg_arguments); ! window_iterate
    while (id) {
        switch (gg_arguments-->0) {
            GG_MAINWIN_ROCK: gg_mainwin = id;
            GG_STATUSWIN_ROCK: gg_statuswin = id;
#IfDef STATUS_WIN_UFRAME;
            GG_STATUSWINUF_ROCK: gg_statuswinuf = id;
#Endif;    
            default: IdentifyGlkObjectExt(1, 0, id, gg_arguments-->0);
        }
        id = glk($0020, id, gg_arguments); ! window_iterate
    }
    if (rnew) {
      IdentifyGlkObjectExt(3);
#IfDef STATUS_WIN_UFRAME;
      if (gg_statuswinuf) glk_window_close(gg_statuswinuf); gg_statuswinuf = 0;
#Endif;       
      if (gg_statuswin) glk_window_close(gg_statuswin); gg_statuswin = 0;
      if (gg_mainwin) glk_window_close(gg_mainwin); gg_mainwin = 0;
      rtrue;
    }
    DrawStatusFrame();
    DrawStatus();
    !!id = glk($0064, 0, gg_arguments); ! fileref_iterate
    !!while (id) {
    !!    switch (gg_arguments-->0) {
    !!        GG_SCRIPTFREF_ROCK: gg_scriptfref = id;
    !!        default: IdentifyGlkObject(1, 2, id, gg_arguments-->0);
    !!    }
    !!    id = glk($0064, id, gg_arguments); ! fileref_iterate
    !!}

    ! Tell the game to tie up any loose ends.
    IdentifyGlkObjectExt(2);
];

[ LanguageContraction text;
    ! Thanks to Giovanni Riccardi
	if (text->0 == 'a' or 'e' or 'i' or 'o' or 'u'
		or 'A' or 'E' or 'I' or 'O' or 'U') return 0;
	if (text->0 == 'z' or 'Z') return 1;
	if (text->0 == 's' or 'S') {
		if (text->1 == 'a' or 'e' or 'i' or 'o' or 'u' 
			or 'A' or 'E' or 'I' or 'O' or 'U') return 2;
		else return 1;
    	}
    if (text->0 == 'p' or 'P') {
		if (text->1 == 'n' or 's') return 1;
		else return 2;
    	}
	if (text->0 == 'g' or 'G') {
    		if (text->1 == 'n') return 1;
		else return 2;
    	}
    return 2;
];

[ PrintAnyToArray _vararg_count arr arrlen str oldstr len;
    @copy sp arr;
    @copy sp arrlen;
    _vararg_count = _vararg_count - 2;

    oldstr = glk($0048); ! stream_get_current
    str = glk($0043, arr, arrlen, 1, 0); ! stream_open_memory
    if (str == 0) return 0;

    glk($0047, str); ! stream_set_current

    @call PrintAnything _vararg_count 0;

    glk($0047, oldstr); ! stream_set_current
    @copy $ffffffff sp;
    @copy str sp;
    @glk $0044 2 0; ! stream_close
    @copy sp len;
    @copy sp 0;

    return len;
];

[ PrintAnything _vararg_count obj mclass;
    if (_vararg_count == 0) return;
    @copy sp obj;
    _vararg_count--;
    if (obj == 0) return;

    if (obj->0 == $60) {
        ! Dictionary word. Metaclass() can't catch this case, so we do
        ! it manually.
        print (address) obj;
        return;
    }

    mclass = metaclass(obj);
    switch (mclass) {
      nothing:
        return;
      String:
        print (string) obj;
        return;
      Routine:
        ! Call the function with all the arguments which are already
        ! on the stack.
        @call obj _vararg_count 0;
        return;
      Object:
        if (_vararg_count == 0) {
            print (name) obj;
        }
        else {
            ! Push the object back onto the stack, and call the
            ! veneer routine that handles obj.prop() calls.
            @copy obj sp;
            _vararg_count++;
            @call CA__Pr _vararg_count 0;
        }
        return;
    }
];

[ KeyCharPrimitive win nostat done res ix jx ch;
    jx = ch; ! squash compiler warnings
    if (win == 0) win = gg_mainwin;
    done = false;
    glk($00D2, win); ! request_char_event
    while (~~done) {
        glk($00C0, gg_event); ! select
        switch (gg_event-->0) {
          5: ! evtype_Arrange
            if (nostat) {
                glk($00D3, win); ! cancel_char_event
                res = $80000000;
                done = true;
                break;
            }
            !DrawStatusLine();
          2: ! evtype_CharInput
            if (gg_event-->1 == win) {
                res = gg_event-->2;
                done = true;
                }
        }
        !ix = HandleGlkEvent(gg_event, 1, gg_arguments);
        if (ix == 2) {
            res = gg_arguments-->0;
            done = true;
        }
        else if (ix == -1) {
            done = false;
        }
    }
  .KCPContinue;
    return res;
];
